package com.steerinfo.ems.tcmdatasourcetimegran.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.ems.tcmdatasourcetimegran.model.TCmDatasourceTimegran;
import com.steerinfo.ems.tcmdatasourcetimegran.service.ITCmDatasourceTimegranService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * TCmDatasourceTimegran RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2019-10-15 09:10
 * 类描述
 * 修订历史：
 * 日期：2019-10-15
 * 作者：generator
 * 参考：
 * 描述：TCmDatasourceTimegran RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tcmdatasourcetimegrans")
public class TCmDatasourceTimegranController extends BaseRESTfulController {

    @Autowired
    ITCmDatasourceTimegranService tCmDatasourceTimegranService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tcmdatasourcetimegran:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TCmDatasourceTimegran> list = tCmDatasourceTimegranService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("tcmdatasourcetimegran:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<TCmDatasourceTimegran> list = tCmDatasourceTimegranService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据TCmDatasourceTimegran对象创建")
    @ApiImplicitParam(name = "tCmDatasourceTimegran", value = "详细实体tCmDatasourceTimegran", required = true, dataType = "TCmDatasourceTimegran")
    //@RequiresPermissions("tcmdatasourcetimegran:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody TCmDatasourceTimegran model){
        String str = model.getDatasourcename() +model.getTimegranid();
            Set<String> strings = tCmDatasourceTimegranService.uniqueKey();
            for (String string : strings) {
                if(str.equals(string)){
                    return failed(model,"数据源名称与时间粒度已存在,请勿重复添加");
                }
            }
        TCmDatasourceTimegran tCmDatasourceTimegran = tCmDatasourceTimegranService.add(model);
        return success(model);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("tcmdatasourcetimegran:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        TCmDatasourceTimegran tCmDatasourceTimegran = tCmDatasourceTimegranService.getById(id);
        return success(tCmDatasourceTimegran);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的tCmDatasourceTimegran信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "tCmDatasourceTimegran", value = "详细实体tCmDatasourceTimegran", required = true, dataType = "TCmDatasourceTimegran")
    })
    //@RequiresPermissions("tcmdatasourcetimegran:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody TCmDatasourceTimegran model){
        model.setId(id);
        TCmDatasourceTimegran tCmDatasourceTimegran = tCmDatasourceTimegranService.modify(model);
        return success(tCmDatasourceTimegran);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("tcmdatasourcetimegran:delete")
    @DeleteMapping(value = "/{id}")
    public RESTfulResult delete(@PathVariable String id){
        if (StringUtils.indexOf(id, ",") == -1) {
            tCmDatasourceTimegranService.delete(id);
        } else {
            tCmDatasourceTimegranService.delete(Arrays.asList(id.split(",")));
        }
        return success();
    }
    
    @ApiOperation(value="获得时间粒度列表", notes="能源调度管理-计量点数据管理-计量点数据录入页面，时间粒度下拉框数据")
    @GetMapping(value = "/getTimegranRmCalpointValue")
    public RESTfulResult getTimegranRmCalpointValue(){
        List<Map> list = tCmDatasourceTimegranService.getTimegranRmCalpointValue();
        return success(list);
    }
    
    @ApiOperation(value="获得时间粒度列表", notes="能源平衡管理-实绩产量管理页面，时间粒度下拉框数据")
    @GetMapping(value = "/getTimegranRmWorkprocProductValue")
    public RESTfulResult getTimegranRmWorkprocProductValue(){
        List<Map> list = tCmDatasourceTimegranService.getTimegranRmWorkprocProductValue();
        return success(list);
    }
    
    @ApiOperation(value="获得时间粒度列表", notes="能源平衡管理-平衡表数据维护页面，时间粒度下拉框数据")
    @GetMapping(value = "/getTimegranRmBalanceValue")
    public RESTfulResult getTimegranVmBalanceValue(){
        List<Map> list = tCmDatasourceTimegranService.getTimegranRmBalanceValue();
        return success(list);
    }
    
    @ApiOperation(value="获得时间粒度列表", notes="能源平衡管理-工序与原材料数据维护页面，时间粒度下拉框数据")
    @GetMapping(value = "/getTimegranRmWorkprocMaterialValue")
    public RESTfulResult getTimegranRmWorkprocMaterialValue(){
        List<Map> list = tCmDatasourceTimegranService.getTimegranRmWorkprocMaterialValue();
        return success(list);
    }


    @ApiOperation(value = "获得时间粒度下拉框",notes = "能源平衡管理-计划产量管理页面，时间粒度下拉框数据")
    @GetMapping(value = "/getTimegranRmTrmworkprocproductvalue")
    public RESTfulResult getTimegranRmTrmworkprocproductvalue(){
        List<Map> list = tCmDatasourceTimegranService.getTimegranRmTrmworkprocproductvalue();
        return success(list);
    }

    @ApiOperation(value = "获得时间粒度下拉框",notes = "能源平衡管理-计划产量管理页面，时间粒度下拉框数据")
    @GetMapping(value = "/getTimegranRmindexvalue")
    public RESTfulResult getTimegranRmindexvalue(){
        List<Map> timegranRmindexvalue = tCmDatasourceTimegranService.getTimegranRmindexvalue();
         return  success(timegranRmindexvalue);
    }


    @ApiOperation(value = "",notes = "能源实际管理-供需项目数据维护 ，时间粒度下拉框数据")
    @GetMapping("/getTimegranRmTrmactvalue")
    public RESTfulResult getTimegranRmTrmactvalue(){
        List<Map> timegranRmTrmactvalue = tCmDatasourceTimegranService.getTimegranRmTrmactvalue();
        return success(timegranRmTrmactvalue);
    }

}
